#!/usr/bin/env pike

/** -*- c -*- ****************************************************************
 * Copyright  1998-99 Klaus Alexander Seistrup @ Magnetic Ink, Copenhagen, DK
 *
 * Qtime.pike -- display time as English sentence.
 *
 * Author  : 1998 Klaus Alexander Seistrup <kseis@magnetic-ink.dk>
 * Created : Sunday, 20th December 1998
 * @(#) $Id: qtime.pike,v 1.3 1999/01/29 11:51:57 kseis Exp $
 *
 * My first program in pike. :-)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but with-
 * out any warranty; without even the implied warranty of merchantability or
 * fitness for a particular purpose.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * New releases of pike can be found on <URL:ftp://ftp.idonex.se/pub/pike/>.
 *****************************************************************************/

/**/
int secs_since_midnight ()
{
  mapping (string:int) now = localtime (time ());

  return (now->hour * 60 + now->min) * 60 + now->sec;
}

/**/
string
qt ()
{
  array hr = ({	"twelve", "one", "two", "three", "four", "five",
		"six", "seven", "eight", "nine", "ten", "eleven" });

  array mn = ({	"", "five ", "ten ", "a quarter ",
		"twenty ", "twenty-five ", "half " });

  array ny = ({	"nearly ", "almost ", "", "just after ", "after " });

  array up = ({	"to ", "", "past " });

  int adj_mins	  = (secs_since_midnight () + 30) / 60 + 27;
  int hours	  = (adj_mins / 60) % 12;
  int minutes	  =  adj_mins % 60;
  int almost	  =  minutes % 5;
  int divisions	  = (minutes / 5) - 5;
  int to_past_idx = divisions > 0 ? 1 : 0;

  if (divisions < 0)
    {
      divisions = -divisions;
      to_past_idx = -1;
    }
  ++to_past_idx;

  string tid = "It's " + ny[almost] + mn[divisions] + up[to_past_idx] + hr[hours];

  if (divisions == 0)
    tid += " o'clock";

  return tid + ".";
}

/**/
int main (int argc, string *argv)
{
  write (qt () + "\n");
}

/*
 * EOF
 */
