#!/usr/bin/jed -script
%% -*- SLang -*-
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright  1997-99 Klaus Alexander Seistrup @ Magnetic Ink, Copenhagen, DK
%%
%% QTime -- display time as English sentence.
%%
%% Author  : 1997 Klaus Alexander Seistrup <kseis@magnetic-ink.dk>
%% Created : Wednesday, 15th January 1997
%% @(#) $Id: qtime.sl,v 1.3 1999/01/29 11:51:57 kseis Exp $
%%
%% This program is free software; you can redistribute it and/or modify it
%% under the terms of the GNU General Public License as published by the Free
%% Software Foundation; either version 2 of the License, or (at your option)
%% any later version.
%%
%% This program is distributed in the hope that it will be useful, but with-
%% out any warranty; without even the implied warranty of merchantability or
%% fitness for a particular purpose.  See the GNU General Public License for
%% more details.
%%
%% You should have received a copy of the GNU General Public License along
%% with this program; if not, write to the Free Software Foundation, Inc.,
%% 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
%%
%% JED and S-Lang can be found at <ftp://space.mit.edu/pub/davis/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

define qt ()
{
  variable msm, hrs, min, alm, div, upt, now;

  variable UP = "to ::past ";
  variable NY = "nearly :almost ::just after :after ";
  variable MN = ":five :ten :a quarter :twenty :twenty-five :half ";
  variable HR = "twelve:one:two:three:four:five:six:seven:eight:nine:ten:eleven";

  $1 = extract_element (strcompress (time (), " "), 3, ' ');

  $2 = integer (extract_element ($1, 0, ':'));
  $3 = integer (extract_element ($1, 1, ':'));
  $4 = integer (extract_element ($1, 2, ':'));

  msm = int ((($2 * 60 + $3) * 60 + $4 + 30) / 60 + 27);
  hrs = int (msm / 60) mod 12;
  min = msm mod 60;
  alm = min mod  5;
  div = int (min / 5) - 5;
  upt = sign (div) + 1;

  if (div < 0)
    div = chs (div);

  strncat ("It's ",
	   extract_element (NY, alm, ':'), extract_element (MN, div, ':'),
	   extract_element (UP, upt, ':'), extract_element (HR, hrs, ':'), 5);

  !if (div)
    strcat(" o'clock");

  strcat (".");
}

define qtime ()
{
  message (qt ());
}

if (BATCH)
{
  qtime ();
  exit_jed ();
}
%
%% EOF %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
