#!/usr/bin/env spanner

/**-*- Spanner -*-************************************************************
 * Copyright  1998-99 Klaus Alexander Seistrup @ Magnetic Ink, Copenhagen, DK
 *
 * QTime -- display time as English sentence.
 *
 * Author  : 1998 Klaus Alexander Seistrup <kseis@magnetic-ink.dk>
 * Created : Sunday, September 13th 1998
 * @(#) $Id: qtime.sp,v 1.3 1999/01/29 11:51:57 kseis Exp $
 *
 * This is my first program in Spanner.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but with-
 * out any warranty; without even the implied warranty of merchantability or
 * fitness for a particular purpose.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Spanner is obtainable from <URL:http://www.ataman.com/spanner/>.
 *****************************************************************************/

import "Date" as "date";

/**/
function secs_since_midnight ()
{
  sys_date = date::now ();

  tm_hour = sys_date.hours ();
  tm_mins = sys_date.minutes ();
  tm_secs = sys_date.seconds ();

  return ((tm_hour * 60) + tm_mins) * 60 + tm_secs;
}

/**/
function qt ()
{
  hr = ["twelve", "one", "two", "three", "four", "five",
        "six", "seven", "eight", "nine", "ten", "eleven"];

  mn = ["", "five ", "ten ", "a quarter ",
        "twenty ", "twenty-five ", "half "];

  ny = ["nearly ", "almost ", "", "just after ", "after "];

  up = ["to ", "", "past "];

  adj_mins	= (secs_since_midnight () + 30) / 60 + 27;
  hours		= (adj_mins / 60) % 12;
  minutes	=  adj_mins % 60;
  almost	=  minutes % 5;
  divisions	= (minutes / 5) - 5;
  to_past_idx	= divisions > 0 ? 1 : 0;

  if (divisions < 0)
    {
      divisions = -divisions;
      to_past_idx = -1;
    }
  ++to_past_idx;

  tid = "It's " + ny[almost] + mn[divisions] + up[to_past_idx] + hr[hours];

  if (divisions == 0)
    tid += " o'clock";

  return tid + ".";
}

/**/
function qtime ()
{
  println (qt ());
}

qtime ();

/* EOF */
